/* htimdex.cmd V.015 erstellt ein html-inhaltsverzeichnis zu einer verzeichnisstruktur */
/* mit bildern. generiert thumbnails usw. */
/* (c) ilja kaufmann - TeamOS/2 Franken - May 2001 - email:kiwi@perelin.de */


/* things that could be set by the user */
/* but it's better to use the htimdex.cfg files in the htmlX-directories for that. */
/* so let these settings here remain as default */

htmlsourcedir_name='html1'         /* directory within the home_dir, that contains the html-sources   */
iconsizex=100                      /* maximum width of the created thumbnails   */
iconsizey=80                       /* maximum height of the created thumbnails   */
text_unbekannt='unknown format'    /* text for unknown file-formats instead of image-format   */
iconform='gif'                     /* thumbnail format, only 'gif' 'jpg' 'png' allowed   */
html_stamm='$stamm'                /* where the html-index will be generated, must be an existing directory, !cAsEsEnSiTiVe!, default: html_stamm='$stamm' */
extensions='imgs.pcx.all'          /* archive-files to include within the index - could be set to 'all' 'imgs' '.gif.jpg.png' etc  */
wholepath=0                        /* 1 - whole filepaths are compared. 0 - only filenames, size, date, time are compared, so it's possible to move a picture, without having to generate a new icon for it */
onefile=0                          /* 1 - only one index-file will be generated, containing all indexed images etc. 0 - one index-file for each subfolder  */
repluml=0                          /* 1 - all folder-/filenames in the to-do-directory-structure are checked for german umlaute, which then will be replaced */
forceid=0                          /* 1 - check files again that are not allready identified as images (after installing a new delegate for convert) */
doidentify=1                       /* 0 - for non-image-directories/archieves, htimdex will not try to identify the files as images */
what_to_log=4                      /* log-level. the higher the number (0-9) the more info will be in the log-file */

/* things that should not be modified by the user (level1) */

statepipe='\pipe\htimdex'          /* Informations Pipe, die von anderen programmen ausgelesen werden kann */
htmldir='htimdex'                  /* ordnername fr die html-files und die thumbnails */
safedir='safe'                     /* der inhalt dieses verzeichnisses innerhalb von htmldir wird nicht gelscht, dient z.b. fr im html-code verwendete bilder geeignet */
htmlind='index.html'               /* filename fr das index file im hauptverzeichnis, default: 'index.html' */
htmlstr='struct.html'              /* filename fr das htmlfile mit der verzeichnisstruktur, default: 'struct.html' */
icondir='icons'                    /* verzeichnisname fr die thumbnails im index, default: 'icons' possible: '' */
iconpref='ic'                      /* prefix fr die namen der generierten icons, default: 'ic' */
htmlpref='ht'                      /* prefix fr die namen der generierten html-files, default: 'ht' */
htmlform='html'                    /* sufix fr die erzeugten html-files, nur 'html' und 'htm' sinnvoll  */
cfgfile='htimdex.cfg'              /* name der config files in den html-vorlage-verzeichnissen, default: 'htimdex.cfg' */
dummyic='dummy'                    /* name des dummy-thumbnails wenn kein anderes gefunden werden kann, liegt im safe ordner, default: 'dummy' */

/* further initialisation and things that should not be modified by the user (level2) */
/* die reihenfolge der folgenden zeilen ist sehr wichtig um die richtigen pfade zu finden/erzeugen! */
/* the order of the following lines is very importent, to determine the correct pathes! */

Call rxfuncadd 'SysFileTree', 'RexxUtil', 'SysFileTree'
Call rxfuncadd 'SysWaitNamedPipe', 'RexxUtil', 'SysWaitNamedPipe'
Call rxfuncadd 'SysPutEA', 'RexxUtil', 'SysPutEA'

'@Echo off'
br=insert(D2C(13), D2C(10))
home_dir='E:\Utility\Rexxskripte\htimdex'

log_file=home_dir'\htimdex.log'         /* Filename des log-files */
if stream(log_file,'C','query exists')<>'' then 'del 'log_file
call log 0, 'generated at 'time()' 'date()
call log 0, 'Log-File, htimdex015.cmd - Make_Image_HTML_Index 28.04.2001'

aktuell=directory()
parse arg given
if pos('log="',given)>0 then parse var given anfang 'log="' what_to_log '"' rest
wherefile=home_dir'\where.ind'          /* file im programmverzeichnis in dem steht, wo schon welche indizes erzeugt wurden */
inffilename='done.ind'                  /* file das ergebnisse frherer durchlufe enthlt - nicht editieren !!! */
stamm=checkgiven(given) /* vor dieser zeile darf das aktuelle verzeichnis nicht verlassen werden !!! */

suchpfad=stamm'\*'                      /* such-vorgabe fr das rekursive suchen von files */
work_dir=home_dir    /* arbeitsverzeichnis = homedir, event homedir+delegatesdir  */

extensions=translate(extensions)
stamm_l=length(stamm)

rc=stream(statepipe,'C','open write')
if rc='READY:' then existpipes=1
else existpipes=0


call log 2, 'home directory     : 'home_dir
call log 2, 'calling directory  : 'aktuell
call log 2, 'calling parameters : 'given
call log 2, 'to-do directory    : 'stamm
call log 2, 'result directory   : 'html_stamm
call log 2, 'html-source-dir    : 'htmlsourcedir
call log 2, 'working directory  : 'directory(work_dir)
call log 1, 'settings: doidentify='doidentify' forceid='forceid' onefile='onefile' wholepath='wholepath' repluml='repluml' what_to_log='what_to_log

/* einlesen aller dateinamen (komplette pfadangaben) rekursiv mit dateiinfos */
/* einlesen aller verzeichnisnamen ohne weitere infos und ohne dateien */

if datei.0=0 then do
   call log 0, 'nothing to do ---> exiting'
   rc=lineout(log_file)
   rc=directory(aktuell)
   exit
end  /* Do */

/* wenn gewnscht werden in filenamen die umlaute ersetzt */

if repluml=1 then do
  call replace_umlaute(stamm'\')
  if 1=2 then do
  infos_alt=replaceall('',infos_alt,'oe')
  infos_alt=replaceall('',infos_alt,'ae')
  infos_alt=replaceall('',infos_alt,'ue')
  infos_alt=replaceall('',infos_alt,'Oe')
  infos_alt=replaceall('',infos_alt,'e')
  infos_alt=replaceall('',infos_alt,'e')
  infos_alt=replaceall('',infos_alt,'sz')
  end  /* Do */
end /* if */

call SysFileTree suchpfad, 'datei', 'FST'
call SysFileTree suchpfad, 'ordner', 'DSO'

/* ausschlieen der event. schon generierten html-pfade und dateien */
/* deren namen werden extra gespeichert */
/* krzen aller pfadangaben auf relative angaben bzgl. stamm */

dateianz=0
indexanz=0

/* '@echo search > 'statepipe */
/* '@echo all > 'countpipe */
do i=1 to datei.0
   select
     when pos(translate(html_stamm'\'htmlind),translate(datei.i))>0 then do         /* datei.i ist altes index.html */
       call log 6, 'I- found old indexfile 'substr(datei.i,pos(translate(html_stamm'\'htmlind),translate(datei.i)))
     end  /* Do */
     when pos(translate(html_stamm'\'htmldir'\'),translate(datei.i))>0 then do      /* datei.i ist bestandteil des alten indexes */
       indexanz=indexanz+1
       stamm_pos=pos(translate(html_stamm),translate(datei.i))
       index.indexanz=substr(datei.i,stamm_pos)
       call log 6, 'I- 'indexanz'  'index.indexanz
     end  /* Do */
     when pos(translate(home_dir'\'),translate(datei.i))>0 then do                  /* datei ist bestandteil von htimdex */
       call log 6, 'P- found part of myself 'substr(datei.i,pos(translate(home_dir'\'),translate(datei.i)))
     end  /* Do */
     otherwise do                                            /* wirklich eine zu untersuchende datei/bild */
       dateianz=dateianz+1
       stamm_pos=pos(translate(stamm),translate(datei.i))
       datei.dateianz=substr(datei.i,1,stamm_pos-1)''substr(datei.i,stamm_pos+stamm_l+1)
       call log 6, 'F- 'dateianz'  'datei.dateianz
     end /* otherwise */
   end /* select */
end /* do */

found_stamm=0
found_icons=0
found_saved=0

if translate(html_stamm)<>translate(stamm) then do         /* wenn das indexverzeichnis nicht im archiv liegen soll bzw. liegt */
  call SysFileTree html_stamm'\'htmldir'\*', 'index', 'FSO'
  if index.0>0 then do
  do i=1 to index.0
    call log 3, 'I2- 'i'  'index.i
    if pos(translate(html_stamm'\'htmldir),translate(index.i))>0 & found_stamm<>1 then do
       found_stamm=1     /* altes indexverzeichnis gefunden */
       call log 3, 'found Index directory 'index.i
    end /* if */
    if pos(translate(html_stamm'\'htmldir'\'safedir),translate(index.i))>0 & found_saved<>1 then do
       found_saved=1     /* altes safeverzeichnis gefunden */
       call log 3, 'found Safe directory 'index.i
    end /* if */
    if pos(translate(html_stamm'\'htmldir'\'icondir),translate(index.i))>0 & found_icons<>1 then do
       found_icons=1     /* altes iconverzeichnis gefunden */
       call log 3, 'found Icon directory 'index.i
    end /* if */
  end /* do */
  end /*if */
  indexanz=index.0
end  /* if */

datei.0=dateianz
index.0=indexanz

ordneranz=0
if ordner.0>0 then do
do i=1 to ordner.0
   select
     when pos(translate(html_stamm'\'htmldir'\'safedir),translate(ordner.i))>0 then do /* ordner ist das alte safe-verzeichnis */
       found_stamm=1
       found_saved=1     /* altes safeverzeichnis gefunden */
       call log 3, 'found Safe directory 'ordner.i
     end  /* Do */
     when pos(translate(html_stamm'\'htmldir'\'icondir),translate(ordner.i))>0 then do /* ordner ist das alte icon-verzeichnis */
       found_stamm=1
       found_icons=1     /* altes iconverzeichnis gefunden */
       call log 3, 'found Icon directory 'ordner.i
     end  /* Do */
     when pos(translate(html_stamm'\'htmldir),translate(ordner.i))>0 then do  /* ordner ist das alte indexverzeichnis*/
       found_stamm=1
       call log 3, 'found Index directory 'ordner.i
     end  /* Do */
     when pos(translate(home_dir'\'),translate(ordner.i))>0 then do  /* ordner ist das verzeichnis von htimdex */
       call log 3, 'found my own directory 'ordner.i
     end  /* Do */
     otherwise do                              /* ordner ist teil des imagearchives */
       ordneranz=ordneranz+1
       ordner.ordneranz=substr(ordner.i,stamm_l+2)
       call log 6, 'D- 'ordneranz'  'ordner.ordneranz
     end /* otherwise */
   end  /* select */
end /* do */
end /* if */

ordner.0=ordneranz
if found_stamm=0 then do
   call log 3, 'Creating index-directory: 'html_stamm'\'htmldir
   'mkdir 'html_stamm'\'htmldir
end /* if */
if found_icons=0 then do
   call log 3, 'Creating icon-directory: 'html_stamm'\'htmldir'\'icondir
   'mkdir 'html_stamm'\'htmldir'\'icondir
end  /* Do */
if found_saved=0 then do
   call log 3, 'Creating safe-directory: 'html_stamm'\'htmldir'\'safedir
   'mkdir 'html_stamm'\'htmldir'\'safedir
end  /* Do */



/* string erzeugen in dem alle gif-file-namen stehen die im safedir vorkommen, fr extensionspezifische dummyicons */

call SysFileTree home_dir'\'safedir'\*.'iconform, 'safeicons', 'FO'
dummyicons=' '
if safeicons.0>0 then do
  do i=1 to safeicons.0
     dummyicons=dummyicons' 'safeicons.i
  end /* do */
end  /* Do */
call log 3, 'Dummyicons='dummyicons
safeicons=''



call log 1, 'found 'index.0' existing indexfiles, 'datei.0' potential imagefiles within 'ordner.0' subfolders'

/* auslesen der infos zu den gefundenen files */

do i=1 to datei.0
  jahr.i=substr(datei.i,1,2)
  monat.i=substr(datei.i,4,2)
  tag.i=substr(datei.i,7,2)
  stunde.i=substr(datei.i,10,2)
  minute.i=substr(datei.i,13,2)
  gpos=lastpos(' ',datei.i,26)
  groesze.i=substr(datei.i,gpos+1,26-gpos)
  datei.i=substr(datei.i,36)
  infozeile.i=datei.i'_*_'groesze.i'_**_'tag.i'.'monat.i'.'jahr.i'_***_'stunde.i':'minute.i
  if wholepath=1 then lookfor=infozeile.i
    else lookfor=substr(infozeile.i,lastpos('\',infozeile.i)+1)
  call log 8, 'look for 'lookfor
end /* do */


/* beginn, das done.idx file zu schreiben mit den settings fuer diesen durchlauf */

rc=lineout(inffile, 'iconsizex="'iconsizex'"')
rc=lineout(inffile, 'iconsizey="'iconsizey'"')
rc=lineout(inffile, 'text_unbekannt="'text_unbekannt'"')
rc=lineout(inffile, 'extensions="'extensions'"')
rc=lineout(inffile, 'htmlsourcedir="'htmlsourcedir_name'"')
rc=lineout(inffile, 'doidentify="'doidentify'"')


/* welche bilder sind neu oder verndert - sonst alte gren und iconnamen auslesen */
/* kriterium fr unverndertes bild: die fr das neue infofile generierte infozeile mu in der alten infodatei stehen */



iconnr=1
alt_pos=1
up_infos_alt=translate(infos_alt)

do i=1 to datei.0

  call tell i' of 'datei.0

  l=length(datei.i)
  p=lastpos('.',datei.i)
  if l-p<6 & p>0 then extension.i=translate(substr(datei.i,p+1))
  else extension.i=''

  /* gibt es fr dieses file schon einen eintrag im info.ind file? wenn ja dann ... */

  if wholepath=1 then lookfor=infozeile.i
    else lookfor=substr(infozeile.i,lastpos('\',infozeile.i)+1)

  ipos=pos(translate(lookfor),up_infos_alt,alt_pos) /* diese doppelte suche sollte den befehl pos etwas beschleunigen, da nur von alt_pos an gesucht werden mu und nicht durch alles */
  if ipos=0 then ipos=lastpos(translate(lookfor),up_infos_alt,alt_pos) /* zeitgewinn ca. 10% - 15% */
  alt_pos=ipos+1

  if ipos>0 then do
    iposm=pos(br,infos_alt,ipos)           /* nchster zeilenumbruch nach gefundener info */
    ipos1=pos('_****_',infos_alt,ipos)     /* begin size */
    ipos1a=pos('_*',infos_alt,ipos+length(lookfor))   /* end erste-hlfte-suchinfo =! begin size */
    ipos2=pos('x',infos_alt,max(1,ipos1))         /* begin ysize innerhalb von size */
    ipos3=pos('_*****_',infos_alt,max(1,ipos))    /* begin icondateiname */
    ipos3a=pos('_*',infos_alt,max(1,ipos2+1))     /* end size =! begin icondateiname*/
    ipos4=pos('_******_',infos_alt,max(1,ipos))   /* begin sonstiges */
    ipos4a=pos('_*',infos_alt,max(1,ipos3+1))     /* end icondateiname =! begin sonstiges*/
    ipos5=pos('_*******_',infos_alt,max(1,ipos))  /*   !  begin iconsize  (integritycheck altered for backwardcompatibility)  */
    ipos5a=pos('_*',infos_alt,max(1,ipos4+1))     /*   !  end sonstiges =! begin iconsize*/
    ipos6=pos('x',infos_alt,max(1,ipos5))         /*   !  begin icon-ysize innerhalb von iconsize */
    ipos7=pos(br,infos_alt,max(1,ipos4))          /* nchster zeilenumbruch nach sonstiges =! zeilenumbruch */
    call log 9, 'F- 'i'     positionen: 1:'ipos1' 1a:'ipos1a' 2:'ipos2' 3:'ipos3' 3a:'ipos3a' 4:'ipos4' 4a:'ipos4a' 5:'ipos5' 5a:'ipos5a' 6:'ipos6' m:'iposm' 7:'ipos7
    if ipos7=iposm & ipos1*ipos2*ipos3*ipos4>0 & ipos1-ipos1a+ipos3-ipos3a+ipos4-ipos4a=0 then do
      xsize.i=substr(infos_alt,ipos1+6,ipos2-ipos1-6)
      ysize.i=substr(infos_alt,ipos2+1,ipos3-ipos2-1)
      icondatei.i=substr(infos_alt,ipos3+7,ipos4-ipos3-7)
      if ipos5*ipos6*ipos5a>0 & ipos5=ipos5a & ipos6<ipos7 then do
        sonstiges.i=substr(infos_alt,ipos4+8,ipos5-ipos4-8)
        icsizex.i=substr(infos_alt,ipos5+9,ipos6-ipos5-9)
        icsizey.i=substr(infos_alt,ipos6+1,ipos7-ipos6-1)
      end  /* if */
      else do  /* alles unter diesem else ist fr backwardscompatibility zu versionen bis htimdex13 */
        sonstiges.i=substr(infos_alt,ipos4+8,ipos7-ipos4-8)
        if xsize.i<>' ' & ysize.i<>' ' & sonstiges.i<>text_unbekannt & icondatei.i<>dummyic'.'iconform then do
          icsizex.i=min(iconsizex,trunc(iconsizey/ysize.i*xsize.i+0.5))
          icsizey.i=min(iconsizey,trunc(iconsizex/xsize.i*ysize.i+0.5))
        end /* if */
        else do
           icsizex.i=min(iconsizex,iconsizey)
           icsizey.i=icsizex.i
        end  /* Do */
      end  /* else */
      status.i=5  /* bedeutet: dieses file wurde schonmal erfolgreich gecheckt ohne jegliches icon dafr zu finden */
      if icondatei.i<>safedir'\found.not' & forceid=0 then do  /* fr dieses icon ist die gre schon bekannt */
         suchicon=substr(icondatei.i,lastpos('\',icondatei.i)+1)
         icsizex.suchicon=icsizex.i
         icsizey.suchicon=icsizey.i
         icsizef.suchicon="yes"
      end  /* if */
      if icondatei.i<>safedir'\'dummyic'.'iconform & icondatei.i<>dummyic'.'iconform & icondatei.i<>safedir'\found.not' then status.i=3
      /* status.i=3 bedeutet: fr dieses file gibts eine icondatei */
      if xsize.i<>' ' & ysize.i<>' ' & sonstiges.i<>text_unbekannt & icondatei.i<>safedir'\'dummyic'.'iconform then status.i=4
      /* status.i=4 bedeutet: es handelt sich wirklich um ein frher bereits sauber erkanntes bild */
      call log 4, 'F- 'i' 'datei.i' old accepted, status: 'status.i
    end  /* if */
    else do
      status.i=0  /* bedeutet: fr dieses file gibts noch nix */
      call log 0, 'F- 'i' 'datei.i' !!! Infofile 'inffile' is corrupt, status: 'status.i
    end  /* else */
  end  /* if */
  else do
    status.i=0  /* bedeutet: fr dieses file gibts noch nix */
    call log 4, 'F- 'i' 'datei.i' searchstring "'lookfor'" not found, status: 'status.i
  end  /* else */


   /* ber die neuen bzw. vernderten files identify laufen lassen */
   /* auch, wenn es kein bereits identifiziertes bild ist und neues identify vom user verlangt wird */

   if status.i=0 | (status.i<>4 & forceid=1) then do
     info=''
     if doidentify=1 then do
       'identify "'stamm'\'datei.i'" | rxqueue'
       call log 7, 'identify "'stamm'\'datei.i'" | rxqueue'
     end /* if */
     do while queued()>0
       parse upper pull infoline
       info=info''infoline
     end /* while */
     select           /* welches grafikformat haben wir hier denn... */
        when pos(' NO DELEGATE ',info)>0 | pos(' INVALID ',info)>0 then do
          call nix
        end  /* Do */
        when info='' then do
          call nix
        end  /* Do */
        when extension.i='WMF' then do
          call wmf
        end  /* Do */
        when extension.i='CPT' then do
          call nix
        end  /* Do */
        when pos(' GIF ',info)>0 then do
          call gif
        end  /* Do */
        when pos(' PCX ',info)>0 then do
          call pcx
        end  /* Do */
        otherwise do
          call rest
        end /* otherwise */
     end  /* select */
     select            /* und was fuer ein thumbnail geben wir dem jetzt... */
        when sonstiges.i=text_unbekannt then do    /* es handelt sich nicht um ein erkanntes bild ... */
          status.i=5  /* bedeutet: versuch mal, ob sich fr dieses file entspr. extension ein icon findet */
        end  /* when */
        otherwise do
          do while pos(translate(icondir'\'iconpref''iconnr'.'iconform),translate(infos_alt))>0  /* iconnummer suchen die es noch nicht gibt */
             iconnr=iconnr+1
          end /* do */
          icondatei.i=icondir'\'iconpref''iconnr'.'iconform
          iconnr=iconnr+1
          status.i=2  /* bedeutet: fr dieses bild gibts infos, thumbnail soll erzeugt werden */
        end /* otherwise */
     end  /* select */
     call log 6, '   'i' new thumbnail/icon to be created, status: 'status.i

   end  /* if */

   /* erzeugen der bilder-thumbnails mit convert, auf gre und farbtiefe trimmen mit mogrify' */

   zielfile=html_stamm'\'htmldir'\'icondatei.i
   if status.i=2 | (status.i=4 & stream(zielfile,'C','query exists')='') then do
     icsizex.i=min(iconsizex,trunc(iconsizey/ysize.i*xsize.i+0.5),xsize.i)
     icsizey.i=min(iconsizey,trunc(iconsizex/xsize.i*ysize.i+0.5),ysize.i)
     quellfile=stamm'\'datei.i
     select
        when sonstiges.i='?' then do
           call log 0, 'was komisches gefunden'
        end  /* Do */
        otherwise do
           call log 7, 'status: 'status.i' --> 'replaceall('\','convert -geometry 'icsizex.i'x'icsizey.i' -colors 16 "'quellfile'" 'zielfile,'/')
           replaceall('\','convert -geometry 'icsizex.i'x'icsizey.i' -colors 16 "'quellfile'" 'zielfile,'/')
        end /* otherwise */
     end  /* select */
     status.i=4
   end  /* if */

   /* erzeugen der nichtbilder icons, bestimmen deren groesze  */

   if status.i=5 then do
     suchicon=extension.i'.'iconform
     suchiconpos=pos(translate(suchicon),translate(dummyicons))
     if suchiconpos>0 then do                 /* aber zu der extension des files existiert ein iconvorschlag */
       icondatei.i=safedir'\'substr(dummyicons,suchiconpos,length(suchicon))
     end /* if */
     else do
       suchicon=dummyic'.'iconform
       suchiconpos=pos(translate(suchicon),translate(dummyicons))
       if suchiconpos>0 then icondatei.i=safedir'\'substr(dummyicons,suchiconpos,length(suchicon))  /* kein passender iconvorschlag, aber ein dummyicon gefunden */
       else do                                /* garnix gefunden */
         icondatei.i=safedir'\found.not'
         icsizex.i=1
         icsizey.i=1
         suchicon='found.not'
       end  /* Do */
     end /* else */
     if suchiconpos>0 then do   /* es wurde ein potentielles nichtbildericon gefunden also ... */
       if icsizef.suchicon="yes" then do  /* dieses icon wurde schon verwendet */
         icsizex.i=icsizex.suchicon
         icsizey.i=icsizey.suchicon
       end  /* if */
       else do                                               /* dieses icon wurde noch nicht verwendet */
         quellfile=home_dir'\'icondatei.i
         info=''
         call log 7, replaceall('\','identify "'quellfile'" | rxqueue','/')
         replaceall('\','identify "'quellfile'" | rxqueue','/')
         do while queued()>0
           parse upper pull infoline
           info=info''infoline
         end /* while */
         if pos(' GIF ',info)=0 & pos(' JPEG ',info)=0 & pos(' PNG ',info)=0 then do   /* kein zulaessiges icon */
           icondatei.i=safedir'\found.not'
           icsizex.i=1
           icsizey.i=1
           suchicon='found.not'
           call log 0, 'iconfile 'home_dir'\'safedir'\'suchicon' could not be identified - check it. i will skip it'
         end  /* if */
         else do                                            /* ist ein brauchbares icon */
           ipos1=lastpos('X',info)
           ipos2=lastpos(' ',info,ipos1)
           ipos3=pos('+',info,ipos1)
           if ipos3=0 then ipos3=pos(' ',info,ipos1)
           if ipos1*ipos2*ipos3>0 then do
             icsizex.i=substr(info,ipos2+1,ipos1-ipos2-1)
             icsizey.i=substr(info,ipos1+1,ipos3-ipos1-1)
           end  /* if */
           else do
             call log 0, '!!! s.th. went wrong with the iconfile 'home_dir'\'safedir'\'suchicon' could not determine its size. i will try anyhow'
             icsizex.i=iconsizex
             icsizey.i=iconsizey
           end  /* else */
           if icsizex.i>iconsizex | icsizey.i>iconsizey then do  /* icon ist zu grosz */
             old_icsizex=icsizex.i
             old_icsizey=icsizey.i
             icsizex.i=min(iconsizex,trunc(iconsizey/old_icsizey*old_icsizex+0.5))
             icsizey.i=min(iconsizey,trunc(iconsizex/old_icsizex*old_icsizey+0.5))
             zielfile=html_stamm'\'htmldir'\'icondatei.i
             call log 7, 'status='status.i' -icon-> 'replaceall('\','convert -geometry 'icsizex.i'x'icsizey.i' -colors 16 "'quellfile'" 'zielfile,'/')
             replaceall('\','convert -geometry 'icsizex.i'x'icsizey.i' -colors 16 "'quellfile'" 'zielfile,'/')
           end /* if */
           else do  /* icon ist nicht zu gro, lschen, damit es aus save-ordner neu kopiert wird, falls gendert */
             ziel=replaceall('/',html_stamm'\'htmldir'\'icondatei.i,'\')
             if stream(ziel,'C','query exists')<>'' then do
               call log 4, 'del 'ziel
               'del 'ziel
             end  /* if */
           end  /* Do */
         end /* else */
       end  /* else */
     end /* if */
     status.i=3  /* bedeutet: fr dieses nicht-bild-file gibts ein icon */
     icsizef.suchicon="yes"
     icsizex.suchicon=icsizex.i
     icsizey.suchicon=icsizey.i
   end  /* if */

   infozeile.i=infozeile.i'_****_'xsize.i'x'ysize.i'_*****_'icondatei.i'_******_'sonstiges.i'_*******_'icsizex.i'x'icsizey.i
   call log 8, 'infoline:  'infozeile.i
   rc=lineout(inffile, infozeile.i)

end  /* do */


rc=stream(inffile,'c','close')
call log 5, 'lineout 'inffile' ende, rc='rc /* schlieszen des done.index files */


/* vergleichen des inhaltes des alten htmlverzeichnisses mit den neuen icondateinamen */
/* alle files, die keine neuen icons sind werden gelscht */
/* bei korruptem infofile kann es vorkommen, da bestehende icondateinamen neu vergeben */
/* worden sind. diese werden hier nicht gelscht. beim erzeugen neuer icondateien aber */
/* berschrieben */

/* '@echo del_old > 'statepipe */


infos_alt=translate(readfile(inffile))
tr_inffile=translate(inffile)

do i=1 to index.0
   /* '@echo 'i'/'datei.o' > 'countpipe */
   datei=translate(substr(index.i,lastpos('\',index.i)+1))
   if pos(translate(html_stamm'\'htmldir'\'safedir),translate(index.i))=0 & pos(datei,infos_alt)=0 & pos(datei,tr_inffile)=0 then do
      call log 4, 'deleting 'index.i
      'del "'index.i'"'
   end /* if */
   else call log 5, 'not deleting 'index.i
end /* do */





/*                                                                        */
/*                 ab hier werden die html-files erzeugt                  */
/*                                                                        */

/* '@echo write > 'statepipe */
/* '@echo html > 'countpipe */

/* vorab wird der safe-ordner im home und im zielverzeichnis abgeglichen */

call SysFileTree home_dir'\'safedir'\*', 'safe_dat', 'FO'
if safe_dat.0>0 then do
do i=1 to safe_dat.0
   ziel=replaceall(home_dir,safe_dat.i,html_stamm'\'htmldir)
   if stream(ziel,'C','query exists')='' then do
      call log 4, 'copy 'safe_dat.i' 'ziel
      'copy 'safe_dat.i' 'ziel
   end  /* if */
end /* do */
end /* if */


/* pfade untersuchen */

if translate(html_stamm)=translate(stamm) then do
  if onefile=0 then file_path='../'     /* relative linkpfade normal */
  else file_path=''                     /* relative linkpfade fuer EIN index-file*/
end /* if */
else do
  file_path='file:///'replaceall('\',stamm'/','/')   /* absolute linkpfade */
end /* else*/
if onefile=0 then pfadkorrektur=""
else pfadkorrektur=htmldir'/'



/* erstmal die ordner alphabetisch sortieren */

if ordner.0>1 then do
  do i=1 to ordner.0-1
     found=i
    do j=i+1 to ordner.0
      if ordner.j<ordner.found then found=j
    end /* do */
    merken=ordner.i
    ordner.i=ordner.found
    ordner.found=merken
  end /* do */
end /* if */



/* feststellen wieviele und welche files zu welchem ordner gehoeren */

size_of_all_files=0
anz_all_files=0
/* root directory */
files_in_dir.0.0=0  /*  files_in_dir.ordnernummer.filenummer  files_in_dir.ordnernummer.0=anzahl_der_files_im_ordner  */
size_of_files.0=0
do j=1 to datei.0
  if pos('\',datei.j)=0 & (pos(extension.j,extensions)>0 | pos('ALL',extensions)>0 | (pos('IMGS',extensions)>0 & status.j=4)) then do
    files_in_dir.0.0=1+files_in_dir.0.0
    anz=files_in_dir.0.0
    files_in_dir.0.anz=j
    size_of_files.0=size_of_files.0+groesze.j
  end  /* Do */
end /* do */
size_of_all_files=size_of_all_files+size_of_files.0
anz_all_files=anz_all_files+files_in_dir.0.0

/* alle anderen directories */
if ordner.0>0 then do
  do i=1 to ordner.0
    files_in_dir.i.0=0
    size_of_files.i=0
    do j=1 to datei.0
      test=substr(datei.j,1,lastpos('\',datei.j))
      if translate(test)=translate(ordner.i'\') & (pos(extension.j,extensions)>0 | pos('ALL',extensions)>0 | (pos('IMGS',extensions)>0 & status.j=4)) then do
        files_in_dir.i.0=1+files_in_dir.i.0
        anz=files_in_dir.i.0
        files_in_dir.i.anz=j
        size_of_files.i=size_of_files.i+groesze.j
      end  /* Do */
    end /* do */
    size_of_all_files=size_of_all_files+size_of_files.i
    anz_all_files=anz_all_files+files_in_dir.i.0
  end /* do */
end /* if */




/*                                                                          */
/*                dann die directory struktur erstellen                     */
/*                                                                          */

/* tree-struktur entsprechend dir-schachtel-tiefe berechnen */

deep=0
ordner_deep.0=0
ordner_sym.0.0=4
if ordner.0>0 then do
  deep=1
  do i=1 to ordner.0
     ipos=pos('\',ordner.i)
     aktdeep=1
     ordner_sym.i.0=0
     do while ipos>0
        ordner_sym.i.aktdeep=0
        ipos=pos('\',ordner.i' ',ipos+1)
        aktdeep=aktdeep+1
     end /* do */
     ordner_deep.i=aktdeep
     deep=max(deep,aktdeep)
     ordner_sym.i.aktdeep=6
     davor=aktdeep-1
     ordner_sym.i.davor=2
     try=i-1
     do while ordner_sym.try.davor=0
        ordner_sym.try.davor=ordner_sym.try.davor+1
        try=try-1
     end /* do */
     /* say 'ordner: 'i'-'ordner.i' tiefe: 'aktdeep' try: 'try' davor: 'davor */
     ordner_sym.try.davor=ordner_sym.try.davor+1
  end /* do */
end  /* if */
max_deep=deep


/*           den grafischen baum-aufbau jeder zeile zusammensetzen            */
/*    fuer die reine ordner struct, ohne files                                */

dir_tree=readfile(htmlsourcedir'\dirs_tree.html')        /* fuer ordner structure */
do j=0 to ordner.0
   tree.j=''
   do deep=0 to ordner_deep.j
      tree.j=tree.j''replaceall('$nr',dir_tree,ordner_sym.j.deep)
   end /* do */
end /* do */



/* struktur fr files generieren - root-dir    indizes:  files_sym.ordner.file.deep */
if files_in_dir.0.0>0 then do
  do i=1 to files_in_dir.0.0
    if i=1 then do
      file_sym.0.i.0=ordner_sym.0.0-2
      if ordner_sym.0.0=4 then ordner_sym.0.0=5
    end  /* if */
    else do
      try=i-1
      file_sym.0.i.0=file_sym.0.try.0
      if file_sym.0.try.0=2 then file_sym.0.try.0=3
    end  /* else */
  end /* do */
end  /* if */

/* struktur fr files generieren - other-dirs   indizes:  files_sym.ordner.file.deep */
if ordner.0>0 then do
  do j=1 to ordner.0
    if files_in_dir.j.0>0 then do
      do i=1 to files_in_dir.j.0
        aktdeep=ordner_deep.j
        if i=1 then do
          do deep=0 to aktdeep
            select
              when ordner_sym.j.deep<2 then file_sym.j.i.deep=ordner_sym.j.deep
              when ordner_sym.j.deep>5 then file_sym.j.i.deep=ordner_sym.j.deep-4
              otherwise file_sym.j.i.deep=ordner_sym.j.deep-2
            end  /* select */
          end /* do */
          if ordner_sym.j.aktdeep=6 then ordner_sym.j.aktdeep=7
        end  /* if */
        else do
          try=i-1
          do deep=0 to aktdeep
             file_sym.j.i.deep=file_sym.j.try.deep
          end /* do */
          if file_sym.j.try.aktdeep=2 then file_sym.j.try.aktdeep=3
        end  /* else */
      end /* do */
    end  /* if */
  end /* do */
end  /* if */



/*           den grafischen baum-aufbau jeder zeile zusammensetzen            */
/*    nun fr die struktur von ordnern mit files                              */

ind_tree_file=readfile(htmlsourcedir'\ind_tree.html')    /* fuer ordner+file structur */
do j=0 to ordner.0
   ind_dirtree.j=''
   do deep=0 to ordner_deep.j
      ind_dirtree.j=ind_dirtree.j''replaceall('$nr',ind_tree_file,ordner_sym.j.deep)
   end /* do */
   do i=1 to files_in_dir.j.0  /*   indizes:  files_sym.ordner.file.deep */
      ind_tree.j.i=''
      do deep=0 to ordner_deep.j
         ind_tree.j.i=ind_tree.j.i''replaceall('$nr',ind_tree_file,file_sym.j.i.deep)
      end /* do */
   end /* do */
end /* do */


/*                    das struct generieren                       */

/* einlesen der vorlagen */

dir_top=readfile(htmlsourcedir'\dirs_top.html')
dir_line=readfile(htmlsourcedir'\dirs_line.html')
dir_bot=readfile(htmlsourcedir'\dirs_bot.html')

/* zeile fuer das root-verzeichnis */

line=replaceall('$folder',dir_line,'root')
line=replaceall('$dir',line,'root')
line=replaceall('$tree',line,tree.0)
line=replaceall('$i_mark',line,'0')
line=replaceall('$idxfile',line,htmlpref''0'.'htmlform)
line=replaceall('$aktdeep',line,1)
line=replaceall('$difdeep',line,max_deep)
line=replaceall('$amtdirfiles',line,files_in_dir.0.0)
line=replaceall('$totsize',line,size_of_files.0)

dir_file=dir_top''line

/* zeilen fuer alle subverzeichnisse */

if ordner.0>0 then do
  do i=1 to ordner.0
     line=replaceall('$folder',dir_line,substr(ordner.i,lastpos('\','\'ordner.i)))
     line=replaceall('$dir',line,replaceall('\',ordner.i,'/'))
     line=replaceall('$tree',line,tree.i)
     line=replaceall('$i_mark',line,i)
     line=replaceall('$idxfile',line,pfadkorrektur''htmlpref''i'.'htmlform)
     line=replaceall('$aktdeep',line,ordner_deep.i+1)
     line=replaceall('$difdeep',line,max_deep-ordner_deep.i)
     line=replaceall('$amtdirfiles',line,files_in_dir.i.0)
     line=replaceall('$totsize',line,size_of_files.i)

     dir_file=dir_file''line
  end /* do */
end  /* Do */

dir_file=dir_file''dir_bot

if onefile=0 then do    /* es soll fuer jedes verzeichnis ein eigenes file creiert werden */
  dir_file=replaceall('$root',dir_file,stamm)
  dir_file=replaceall('$struc',dir_file,pfadkorrektur''htmlstr)
  dir_file=replaceall('$copyright',dir_file,'htimdex, kiwi@perelin.de')
  dir_file=replaceall('$first',dir_file,pfadkorrektur''htmlpref'0.'htmlform)
  dir_file=replaceall('$safe',dir_file,pfadkorrektur''safe)
  dir_file=replaceall('$cdate',dir_file,date())
  dir_file=replaceall('$ctime',dir_file,time())
  dir_file=replaceall('$i_first',dir_file,'0')
  dir_file=replaceall('$maxdeep',dir_file,max_deep+1)
  dir_file=replaceall('$htmldir',dir_file,htmldir)
  dir_file=replaceall('$archivsize',dir_file,size_of_all_files)
  dir_file=replaceall('$amtdirs',dir_file,ordner.0)
  dir_file=replaceall('$amtfiles',dir_file,anz_all_files)
  rc=writefile(html_stamm'\'htmldir'\'htmlstr, dir_file)
end  /* if */




/*                                                                         */
/*          zuerst das einfachste: das index file im rootdir               */
/*                                                                         */


if onefile=0 then do    /* es soll fuer jedes verzeichnis ein eigenes file creiert werden */
  ind_file=readfile(htmlsourcedir'\index.html')
  ind_file=replaceall('$fullstruct',ind_file,dir_file)
  ind_file=replaceall('$root',ind_file,stamm)
  ind_file=replaceall('$struc',ind_file,htmldir'/'htmlstr)
  ind_file=replaceall('$first',ind_file,htmldir'/'htmlpref'0.'htmlform)
  ind_file=replaceall('$safe',ind_file,safe)
  ind_file=replaceall('$copyright',ind_file,'htimdex/kiwi@perelin.de')
  ind_file=replaceall('$cdate',ind_file,date())
  ind_file=replaceall('$ctime',ind_file,time())
  ind_file=replaceall('$i_first',ind_file,'0')
  ind_file=replaceall('$maxdeep',ind_file,max_deep+1)
  ind_file=replaceall('$htmldir',ind_file,htmldir)
  ind_file=replaceall('$archivsize',ind_file,size_of_all_files)
  ind_file=replaceall('$amtdirs',ind_file,ordner.0)
  ind_file=replaceall('$amtfiles',ind_file,anz_all_files)
  rc=writefile(html_stamm'\'htmlind, ind_file)
end  /* if */




/*                                                                     */
/* ------  und last but not least die eigentlichen indexfiles  ------  */
/*                                                                     */


ind_top=readfile(htmlsourcedir'\ind_top.html')
ind_line=readfile(htmlsourcedir'\ind_line.html')
ind_dirtop=readfile(htmlsourcedir'\ind_dirtop.html')
ind_dirbot=readfile(htmlsourcedir'\ind_dirbot.html')
ind_bot=readfile(htmlsourcedir'\ind_bot.html')
ind_hlf=readfile(htmlsourcedir'\ind_hlf.html')


durchlaeufe=ordner.0  /* fuer jeden ordner ein file generieren  0=rootdir */
if onefile=1 then durchlaeufe=0  /* wenn nur ein gesamtindexfile gewuenscht wird */


do filenr=0 to durchlaeufe

akt=ind_top

/*                                      */
/* zuerst fr das stammverzeichnis od=0 */
/*                                      */
next=1
if next>ordner.0 then next=0
else next=1
back=ordner.0

ind_mid=''

/* top-dir-zeile */
if filenr=0 | onefile=1 then line=replaceall('$tree',ind_dirtop,ind_dirtree.0)
else line=replaceall('$tree',ind_dirtop,tree.0)

ind_mid=ind_mid''line

/* file-zeilen */
if filenr=0 | onefile=1 then do

line=''
if files_in_dir.0.0>0 then do
  do i=1 to files_in_dir.0.0
    j=files_in_dir.0.i
    datein=replaceall('\',datei.j,'/')
    akt_line=replaceall('$ifile',ind_line,pfadkorrektur''replaceall('\',icondatei.j,'/'))
    akt_line=replaceall('$file',akt_line,file_path''datein)
    akt_line=replaceall('$size',akt_line,groesze.j)
    if status.j=4 then do
      akt_line=replaceall('$xsize',akt_line,xsize.j)
    end /* if */
    else do
      akt_line=replaceall('$xsize',akt_line,'?')
    end /* if */
    if status.j=4 then do
      akt_line=replaceall('$ysize',akt_line,ysize.j)
    end /* if */
    else do
      akt_line=replaceall('$ysize',akt_line,'?')
    end /* if */
    akt_line=replaceall('$name',akt_line,substr(datein,lastpos('/',datein)+1))
    akt_line=replaceall('$ixsize',akt_line,icsizex.j)
    akt_line=replaceall('$iysize',akt_line,icsizey.j)
    akt_line=replaceall('$form',akt_line,sonstiges.j)
    akt_line=replaceall('$date',akt_line,tag.j'.'monat.j'.'jahr.j)
    akt_line=replaceall('$time',akt_line,stunde.j':'minute.j)
    akt_line=replaceall('$tree',akt_line,ind_tree.0.i)
    line=line''akt_line
    if i=trunc(files_in_dir.0.0/2) then line=line''ind_hlf
  end /* do */
end  /* if */

ind_mid=ind_mid''line

end  /* if */


/* bottom-dir-zeile */
line=replaceall('$tree',ind_dirbot,ind_dirtree.0)

ind_mid=ind_mid''line

ind_mid=replaceall('$dir',ind_mid,'root')
ind_mid=replaceall('$folder',ind_mid,'root')
ind_mid=replaceall('$i_mark',ind_mid,'0')
ind_mid=replaceall('$i_next',ind_mid,next)
ind_mid=replaceall('$i_back',ind_mid,back)
ind_mid=replaceall('$next',ind_mid,htmlpref''next'.'htmlform)
ind_mid=replaceall('$back',ind_mid,htmlpref''back'.'htmlform)
ind_mid=replaceall('$aktdeep',ind_mid,1)
ind_mid=replaceall('$difdeep',ind_mid,max_deep)
ind_mid=replaceall('$amtdirfiles',ind_mid,files_in_dir.0.0)
ind_mid=replaceall('$totsize',ind_mid,size_of_files.0)
ind_mid=replaceall('$idxfile',ind_mid,htmlpref''0'.'htmlform)

akt=akt''ind_mid


/*                                          */
/* dann fr alle brigen unterverzeichnisse */
/*                                          */

if ordner.0>0 then do
  do od=1 to ordner.0

    next=od+1
    if next>ordner.0 then next=0
    back=od-1
    if back<0 then back=ordner.0
    ind_mid=''

    /* top-dir-zeile */
    if filenr=od | onefile=1 then line=replaceall('$tree',ind_dirtop,ind_dirtree.od)
    else line=replaceall('$tree',ind_dirtop,tree.od)

    ind_mid=ind_mid''line

    /* file-zeilen */

    if od=filenr | onefile=1 then do

    line=''
    if files_in_dir.od.0>0 then do
      do i=1 to files_in_dir.od.0
        j=files_in_dir.od.i
        datein=replaceall('\',datei.j,'/')
        akt_line=replaceall('$ifile',ind_line,pfadkorrektur''replaceall('\',icondatei.j,'/'))
        akt_line=replaceall('$file',akt_line,file_path''datein)
        akt_line=replaceall('$size',akt_line,groesze.j)
        if status.j=4 then do
          akt_line=replaceall('$xsize',akt_line,xsize.j)
        end /* if */
        else do
          akt_line=replaceall('$xsize',akt_line,'?')
        end /* if */
        if status.j=4 then do
          akt_line=replaceall('$ysize',akt_line,ysize.j)
        end /* if */
        else do
          akt_line=replaceall('$ysize',akt_line,'?')
        end /* if */
        akt_line=replaceall('$name',akt_line,substr(datein,lastpos('/',datein)+1))
        akt_line=replaceall('$ixsize',akt_line,icsizex.j)
        akt_line=replaceall('$iysize',akt_line,icsizey.j)
        akt_line=replaceall('$form',akt_line,sonstiges.j)
        akt_line=replaceall('$date',akt_line,tag.j'.'monat.j'.'jahr.j)
        akt_line=replaceall('$time',akt_line,stunde.j':'minute.j)
        akt_line=replaceall('$tree',akt_line,ind_tree.od.i)
        line=line''akt_line
        if i=trunc(files_in_dir.od.0/2) then line=line''ind_hlf
      end /* do */
    end  /* if */

    ind_mid=ind_mid''line

    end  /* if */



    /* bottom-dir-zeile */
    line=replaceall('$tree',ind_dirbot,ind_dirtree.0)

    ind_mid=ind_mid''line

    ind_mid=replaceall('$dir',ind_mid,ordner.od)
    ind_mid=replaceall('$folder',ind_mid,substr(ordner.od,lastpos('\','\'ordner.od)))
    ind_mid=replaceall('$i_mark',ind_mid,od)
    ind_mid=replaceall('$i_next',ind_mid,next)
    ind_mid=replaceall('$i_back',ind_mid,back)
    ind_mid=replaceall('$next',ind_mid,htmlpref''next'.'htmlform)
    ind_mid=replaceall('$back',ind_mid,htmlpref''back'.'htmlform)
    ind_mid=replaceall('$aktdeep',ind_mid,ordner_deep.od+1)
    ind_mid=replaceall('$difdeep',ind_mid,max_deep-ordner_deep.od)
    ind_mid=replaceall('$amtdirfiles',ind_mid,files_in_dir.od.0)
    ind_mid=replaceall('$totsize',ind_mid,size_of_files.od)
    ind_mid=replaceall('$idxfile',ind_mid,htmlpref''od'.'htmlform)

    akt=akt''ind_mid

  end /* do */
end /* if */

akt=akt''ind_bot

akt=replaceall('$fullstruct',akt,dir_file)
akt=replaceall('$cdate',akt,date())
akt=replaceall('$ctime',akt,time())
akt=replaceall('$root',akt,stamm)
akt=replaceall('$struc',akt,pfadkorrektur''htmlstr)
akt=replaceall('$i_first',akt,'0')
akt=replaceall('$first',akt,pfadkorrektur''htmlpref''0'.'htmlform)
akt=replaceall('$safe',akt,pfadkorrektur''safedir)
akt=replaceall('$copyright',akt,'htimdex, kiwi@perelin.de')
akt=replaceall('$maxdeep',akt,max_deep+1)
akt=replaceall('$htmldir',akt,htmldir)
akt=replaceall('$archivsize',akt,size_of_all_files)
akt=replaceall('$amtdirs',akt,ordner.0)
akt=replaceall('$amtfiles',akt,anz_all_files)

if onefile=0 then do  /* damit es in der kopf und fuzeile auch ersetzt wird */
  next=filenr+1
  if next>ordner.0 then next=0
  back=filenr-1
  if back<0 then back=ordner.0

  if filenr=0 then do  /* root dir */
    akt=replaceall('$dir',akt,'root')
    akt=replaceall('$folder',akt,'root')
    akt=replaceall('$aktdeep',akt,1)
    akt=replaceall('$difdeep',akt,max_deep)
  end  /* if */
  else do /* other dir */
    akt=replaceall('$dir',akt,ordner.filenr)
    akt=replaceall('$folder',akt,substr(ordner.filenr,lastpos('\','\'ordner.filenr)))
    akt=replaceall('$aktdeep',akt,ordner_deep.filenr+1)
    akt=replaceall('$difdeep',akt,max_deep-ordner_deep.filenr)
  end  /* else */
  akt=replaceall('$i_mark',akt,filenr)
  akt=replaceall('$i_next',akt,next)
  akt=replaceall('$i_back',akt,back)
  akt=replaceall('$next',akt,htmlpref''next'.'htmlform)
  akt=replaceall('$back',akt,htmlpref''back'.'htmlform)
  akt=replaceall('$amtdirfiles',akt,files_in_dir.filenr.0)
  akt=replaceall('$totsize',akt,size_of_files.filenr)
  akt=replaceall('$idxfile',akt,htmlpref''filenr'.'htmlform)

  rc=writefile(html_stamm'\'htmldir'\'htmlpref''filenr'.'htmlform,akt)
end /* if */

else rc=writefile(html_stamm'\'htmlind,akt)


end /* do */











/* programmende, logfile abschlieen, wieder in ursprngliches directory wechseln */
/* rc=stream(log_file,'C','close') */
/* '@echo ready > 'statepipe */
/* '@echo all > 'countpipe */
call tell 'exit'
if existpipes=1 then do
  rc=stream(statepipe,'C','close')
end  /* Do */
call log 0, 'finished at 'time()' 'date()
rc=lineout(log_file)
rc=directory(aktuell)
exit






















/* unterprogramme zur infogewinnung verschiedener grafikformate */

gif:
  ipos1=lastpos('X',info)
  ipos2=lastpos(' ',info,ipos1)
  ipos3=pos('+',info,ipos1)
  ipos4=lastpos('C',info)
  ipos5=lastpos(' ',info,ipos4)
  xsize.i=substr(info,ipos2+1,ipos1-ipos2-1)
  ysize.i=substr(info,ipos1+1,ipos3-ipos1-1)
  sonstiges.i='GIF ColorTab:'substr(info,ipos5+1,ipos4-ipos5-1)
return;


pcx:
  ipos1=lastpos('X',info,length(info)-6)
  ipos2=lastpos(' ',info,ipos1)
  ipos3=pos(' ',info,ipos1)
  xsize.i=substr(info,ipos2+1,ipos1-ipos2-1)
  ysize.i=substr(info,ipos1+1,ipos3-ipos1-1)
  sonstiges.i='PCX '
return;


wmf:
  ipos1=lastpos('X',info)
  ipos2=lastpos(' ',info,ipos1)
  ipos3=pos(' ',info,ipos1)
  xsize.i=substr(info,ipos2+1,ipos1-ipos2-1)
  ysize.i=substr(info,ipos1+1,ipos3-ipos1-1)
  if datatype(xsize.i)='NUM' & datatype(ysize.i)='NUM' then do
    ipos4=lastpos('B',info)+2
    ipos5=pos(' ',info,ipos4)
    sonstiges.i='WMF'
  end /* if */
  else do
    call nix
  end  /* else */
return;


rest:
  ipos1=lastpos('X',info,length(info)-6)
  ipos2=lastpos(' ',info,ipos1)
  ipos3=pos(' ',info,ipos1)
  if ipos1*ipos2*ipos3>0 then do
    xsize.i=substr(info,ipos2+1,ipos1-ipos2-1)
    ysize.i=substr(info,ipos1+1,ipos3-ipos1-1)
  end  /* if */
  else do
    xsize.i='?'
    ysize.i='?'
  end  /* else */
  if datatype(xsize.i)='NUM' & datatype(ysize.i)='NUM' then do
    ipos5=lastpos(' ',info)
    ipos4=lastpos(' ',info,ipos5-1)+1
    sonstiges.i=substr(info,ipos4,ipos5-ipos4)
  end /* if */
  else do
    call nix
  end  /* else */
return;


nix:
  xsize.i=' '
  ysize.i=' '
  sonstiges.i=text_unbekannt
return;


/* routine um alle 'such' in der variable 'in' durch den ausdruck 'durch' zu ersetzen, beginnend bei 'ab' */

replaceall:
  parse arg such,in,durch,ab
  if ab="" then ab=1
  such_l=length(such)
  durch_l=length(durch)
  ipos=pos(such,in,ab)
  do while ipos>0
    in=substr(in,1,ipos-1)''durch''substr(in,ipos+such_l)
    ipos=pos(such,in,ipos+durch_l)
  end  /* while */
return in;


/* routine zum lesen ganzer files in eine variable */

readfile:
  parse arg filename
  rc=stream(filename,'C','open read')
  laenge=chars(filename)
  call log 5, 'reading 'filename' 'laenge
  in=charin(filename, 1, laenge)
  rc=stream(filename,'C','close')
return in;


/* routine zum schreiben ganzer files aus einer variable */

writefile:
  parse arg filename,out
  call log 5, 'writing 'filename' 'length(out)
  if stream(filename,'C','query exists')<>'' then 'del 'filename
  rc=stream(filename,'C','open')
  if rc<>'READY:' then call log 0, 'failed to open file for writing, returncode 'rc
  else do
    rs=charout(filename, out, 1)
    rc=stream(filename,'C','close')
  end  /* Do */
return rs;


/* routine zum schreiben eines log-files, oder bildschirmausgabe der statusberichte */

log:
  parse arg wert,tolog
  if wert<what_to_log then do
    say substr(tolog,1,73)'...'
    /* rc=charout(log_file, tolog''br) */
    rc=lineout(log_file,tolog)
  end /* if */
return;



/* routine die checkt, was an htimdex uebergeben wurde */

checkgiven:
  parse arg gibs
  if length(gibs)=0 | pos('-h',gibs)>0 then do     /* hilfe ausgeben und progr. abbrechen */
     say ' '
     say 'usage: htimdex [parameter] imagedirectory'
     say 'or drag a directory to the programmobjekt'
     say 'parameters (space separated):'
     say 'src="htmlsourcedir"   one of the html source dirs in the htimdex home directory'
     say 'tnx="size"            max x-size of the generated thumbnails in pixels'
     say 'tny="size"            max y-size of the generated thumbnails in pixels'
     say 'tuk="unknown"         textoutput instead of imagetype for unknown files'
     say 'idx="resultdirectory" where the generated index should appear (default is'
     say '                      idx="$stamm" for the calling directory)'
     say 'ext=".gif.jpg.pcx"    extensions of the files to be shown in the index '
     say '                      special: "all" - all files, "imgs" - identified imgs.'
     say 'cmp="0"               or =1 when already generated icons should be compared'
     say '                      by whole path, =0 - only by filename, size, date, time'
     say 'idt="1"               if set to ="0" htimdex does not try to identify the'
     say '                      files as images - use "0" for non-image-directories'
     say 'log="3"               from 0 to 9, changes the amount of info to store in'
     say '                      the log file of htimdex'
     say '/uml                  flag, if set, all dirs and files in imagedirectory are'
     say '                      checked for german umlaute which got replaced ->ue etc.'
     say '/fid                  when you installed a new delegate for convert, use this'
     say '                      to force a new identification of not identified files'
     say 'press enter to quit'
     pull nix
     exit
  end  /* Do */
  else do

     /* aus bergabewerten den zu bearbeitenden pfad ermitteln */

     gibs=strip(replaceall("'",gibs,'"'))      /* einfache in doppelte anfhrungszeichen umwandeln */
     if right(gibs,1)='"' then do             /* bergebenen verzeichnisnamen heraussuchen */
       pf_ende=length(gibs)-1                 /* fall 1: er ist mit quotes versehen */
       pf_anfg=max(lastpos('"',gibs,pf_ende)+1,1)
     end /* if */
     else do                                  /* fall 2: ohne quotes - also durch spaces abgetrennt */
       pf_ende=length(gibs)
       pf_anfg=max(lastpos(' ',gibs,pf_ende)+1,1)
     end  /* else */
     pfad=substr(gibs,pf_anfg,pf_ende-pf_anfg+1)
     if right(pfad,1)="/" | right(pfad,1)="\" then pfad=left(pfad,pf_ende-pf_anfg)   /* slashes am pfadende entfernen */
     pfad=checkdir(pfad)


     /* im programmverzeichnis nachsehen, ob dieser pfad schonmal bearbeitet wurde und wenn ja, wo der index erzeugt wurde */

     html_stamm_changed=0
     wheredone=readfile(wherefile)          /* file einlesen in dem steht, wo schon frher welcher index erzeugt wurde */
     wpos=pos(translate(pfad)'_*_',translate(wheredone))   /* kommt der aktuelle pfad darin vor ? */
     if wpos>0 then do                                /* dann wird der damalige index-pfad ermittelt */
       wpos1=wpos+length(pfad)
       wpos1a=pos('_*_',wheredone,wpos)
       wpos2=pos(br,wheredone,wpos1a)
       call log 9, 'wpos='wpos' wpos1='wpos1' wpos1a='wpos1a' wpos2='wpos2
       if wpos1=wpos1a & wpos2>0 then do
         html_stamm=substr(wheredone,wpos1+3,wpos2-wpos1-3)
         wheredone=left(wheredone,wpos-1)''substr(wheredone,wpos2+2)
         html_stamm_changed=1
         call log 3, 'found prior result directory: 'html_stamm
       end  /* Do */
     end  /* Do */
     if pos('idx="',gibs)>0 then parse var gibs anfang 'idx="' html_stamm '"' rest  /* override by calling parameter */
     html_stamm=checkdir(replaceall('$stamm',html_stamm,pfad))


     /* das infofile des letzten durchlaufes einlesen und daraus das htmlsource-directory ermitteln */

     inffile=html_stamm'\'htmldir'\'inffilename
     if stream(inffile,'C','query exists')<>'' then do
       infos_alt=readfile(inffile)
       if pos('htmlsourcedir="',infos_alt)>0 then parse var infos_alt anfang 'htmlsourcedir="' htmlsourcedir_name '"' .
       'del 'inffile   /* nach dem lesen loeschen zum neuanlegen */
     end  /* if */
     else do
       infos_alt='   '
       call log 3, 'old Infofile 'inffile' not found'
     end  /* else */



     /* aus dem htmlsourcedir das configfile einlesen */

     old_htmlsourcedir_name=htmlsourcedir_name
     if pos('src="',gibs)>0 then parse var gibs anfang 'src="' htmlsourcedir_name '"' rest  /* wurde ein html-source-verzeichnis angegeben ? */
     htmlsourcedir=checkdir(home_dir'\'htmlsourcedir_name)

     inhalt=readfile(htmlsourcedir'\'cfgfile)                             /* config file einlesen */
     inhalt=replaceall("'",inhalt,'"')
     do while pos(';',inhalt)>0 | pos('#',inhalt)>0 | pos('/*',inhalt)>0  /* komentarzeilen vor analyse lschen */
       kom_anf=max(pos(';',inhalt),pos('#',inhalt),pos('/*',inhalt))
       kom_end=pos(br,inhalt,kom_anf)
       anfang=left(inhalt,kom_anf-1)
       if kom_end>0 then ende=substr(inhalt,kom_end+1)
       else kom_end=""
       inhalt=anfang''ende
     end /* while */



     /* overide defaults by definitions from htimdex.cfg -config file if available */

     if pos('iconsizex="',inhalt)>0 then parse var inhalt anfang 'iconsizex="' iconsizex '"' rest
     if pos('iconsizey="',inhalt)>0 then parse var inhalt anfang 'iconsizey="' iconsizey '"' rest
     if pos('text_unbekannt="',inhalt)>0 then parse var inhalt anfang 'text_unbekannt="' text_unbekannt '"' rest
     if pos('extensions="',inhalt)>0 then parse var inhalt anfang 'extensions="' extensions '"' rest
     if pos('wholepath="',inhalt)>0 then parse var inhalt anfang 'wholepath="' wholepath '"' rest
     if pos('onefile="',inhalt)>0 then parse var inhalt anfang 'onefile="' onefile '"' rest  /* this parameter makes only sense in combination with the correct html-files */

     if pos('html_stamm="',inhalt)>0 & html_stamm_changed=0 & pos('idx="',gibs)=0 then parse var inhalt anfang 'html_stamm="' html_stamm '"' rest


     /* override der parameter aus dem infofile des letzten durchlaufs */

       /* fuer backwardcompatibility begin ... */
     ipos=pos('iconsizex',infos_alt)
     if ipos>0 then do
       iposm=pos(br,infos_alt,ipos)
       iconsizex=substr(infos_alt,ipos+9,iposm-ipos-9)
     end  /* if */
     ipos=pos('iconsizey',infos_alt)
     if ipos>0 then do
       iposm=pos(br,infos_alt,ipos)
       iconsizey=substr(infos_alt,ipos+9,iposm-ipos-9)
     end  /* if */
       /* ... end fuer backwardcompatibility  */

     if pos('iconsizex="',infos_alt)>0 then parse var infos_alt anfang 'iconsizex="' iconsizex '"' .
     if pos('iconsizey="',infos_alt)>0 then parse var infos_alt anfang 'iconsizey="' iconsizey '"' .
     if pos('text_unbekannt="',infos_alt)>0 then parse var infos_alt anfang 'text_unbekannt="' text_unbekannt '"' .
     if pos('extensions="',infos_alt)>0 then parse var infos_alt anfang 'extensions="' extensions '"' .
     if pos('wholepath="',infos_alt)>0 then parse var infos_alt anfang 'wholepath="' wholepath '"' .
     if pos('doidentify="',infos_alt)>0 then parse var infos_alt anfang 'doidentify="' doidentify '"' .
     old_doidentify=doidentify

     /* wenn im aufruf ein neues html-source-dir angegeben wurde, dann doch dessen settings nehmen! */

     if old_htmlsourcedir_name<>htmlsourcedir_name then do
       if pos('iconsizex="',inhalt)>0 then parse var inhalt anfang 'iconsizex="' iconsizex '"' rest
       if pos('iconsizey="',inhalt)>0 then parse var inhalt anfang 'iconsizey="' iconsizey '"' rest
       if pos('text_unbekannt="',inhalt)>0 then parse var inhalt anfang 'text_unbekannt="' text_unbekannt '"' rest
       if pos('extensions="',inhalt)>0 then parse var inhalt anfang 'extensions="' extensions '"' rest
       if pos('wholepath="',inhalt)>0 then parse var inhalt anfang 'wholepath="' wholepath '"' rest
       if pos('onefile="',inhalt)>0 then parse var inhalt anfang 'onefile="' onefile '"' rest  /* this parameter makes only sense in combination with the correct html-files */

       if pos('html_stamm="',inhalt)>0 & html_stamm_changed=0 & pos('idx="',gibs)=0 then parse var inhalt anfang 'html_stamm="' html_stamm '"' rest
     end  /* Do */


     /* overide again by comandline-parameters if available */

     if pos('tnx="',gibs)>0 then parse var gibs anfang 'tnx="' iconsizex '"' rest
     if pos('tny="',gibs)>0 then parse var gibs anfang 'tny="' iconsizey '"' rest
     if pos('tuk="',gibs)>0 then parse var gibs anfang 'tuk="' text_unbekannt '"' rest
     if pos('ext="',gibs)>0 then parse var gibs anfang 'ext="' extensions '"' rest
     if pos('cmp="',gibs)>0 then parse var gibs anfang 'cmp="' wholepath '"' rest
     if pos('idt="',gibs)>0 then parse var gibs anfang 'idt="' doidentify '"' rest

     if pos(' /uml ',' 'gibs)>0 then repluml=1
     if pos(' /fid ',' 'gibs)>0 | (doidentify=1 & old_doidentify<>doidentify) then forceid=1
     if forceid=1 then doidentify=1

     html_stamm=checkdir(replaceall('$stamm',html_stamm,pfad))
     ppos=pos(translate(pfad),translate(html_stamm))
     if ppos>0 then wherepfad=left(html_stamm,ppos-1)'$stamm'substr(html_stamm,ppos+length(pfad))
     else wherepfad=html_stamm
     wheredone=wheredone''pfad'_*_'wherepfad''br
     rc=writefile(wherefile,wheredone)

     inffile=html_stamm'\'htmldir'\'inffilename


  end  /* Do */
return pfad;


/* routine fuer die pipe-ausgabe */

tell:
  parse arg t
  if existpipes=1 then rc=charout(statepipe,t)
return;

/* routine die checkt, ob ein gewnschtes directory existiert und dessen korrekten namen zurckgibt */

checkdir:
  parse arg zutesten
  akt_d=directory()
  neu_d=directory(zutesten)
  if neu_d="" then do
     say "Directory '"zutesten"' not found"
     say "press return to exit"
     pull a
     exit
  end  /* if */
  rc=directory(akt_d)
return neu_d;


/* routine die nach umlauten in filenamen sucht und diese ersetzt */

replace_umlaute:
  parse arg dirname
  if right(dirname,1)='\' then dirname=left(dirname,length(dirname)-1)
  dirname=checkdir(dirname)'\'
  dirname_l=length(dirname)
  call SysFileTree dirname, 'alle', 'SO'
  if alle.0=0 then do
     say 'nothing to do ---> exiting'
     exit
  end  /* Do */
  if alle.0>1 then do      /* namenliste alphabetisch sortieren, damit dirs direkt vor deren files kommen */
    do i=1 to alle.0-1
      found=i
      do j=i+1 to alle.0
        if alle.j<alle.found then found=j
      end /* do */
      merken=alle.i
      alle.i=alle.found
      alle.found=merken
    end /* do */
  end /* if */
  do i=1 to alle.0
    neue.i=replaceall('',alle.i,'oe',dirname_l)
    neue.i=replaceall('',neue.i,'ae',dirname_l)
    neue.i=replaceall('',neue.i,'ue',dirname_l)
    neue.i=replaceall('',neue.i,'Oe',dirname_l)
    neue.i=replaceall('',neue.i,'Ae',dirname_l)
    neue.i=replaceall('',neue.i,'Ue',dirname_l)
    neue.i=replaceall('',neue.i,'sz',dirname_l)
    neue.i=replaceall(' ',neue.i,'_',dirname_l)
  end /* do */
  do i=1 to alle.0
    if alle.i<>neue.i then do   /* fuer alle geanderten namen  */
       if i<alle.0 then do      /* genderte dir-namen in allen nachfolgenden filenamen ndern */
         do j=i+1 to alle.0
            alle.j=replaceall(alle.i,alle.j,neue.i)
         end /* do */
       end  /* Do */
       neu=substr(neue.i,pos('\',neue.i))
       call log 4, 'move "'alle.i'" "'neu'"'
       'move "'alle.i'" "'neu'"'
       call log 7, 'SysPutEA('neue.i',".longname","'substr(neue.i,lastpos('\',neue.i)+1)'")'
       rc=SysPutEA(neue.i,".longname",substr(neue.i,lastpos('\',neue.i)+1))
       /* if SysGetEA(alle.i,'.longname','langername')=0 then do */
       /*   parse var langername 5 langername                    */
       /*   say alle.i' objektname:'langername                   */
       /* end  /* Do */                                          */
    end  /* Do */
  end /* do */
return;








